#!/usr/local/bin/tclsh
#
# cgi script to return search results
# from a LDAP server
# G.O v1.1.0 22-Jan-99
# 

package require cgi
package require Ldap

proc footer {} {

    cgi_hr
    puts "Ldap-search v1.1.0 22-Jan-99 ,
[cgi_url {Gareth Owen} mailto:oweng@aston.ac.uk , Network Systems Group , LiS]"
 
}



proc NoSearchTerm {} {

    puts "I need a search string to work on."
    footer
    exit
}

#
# Ignored if REQUEST_METHOD environment variable is set
# so use for debugging from cmd line
cgi_input "host=dir&port=389&base=o%3DAston%20University,c%3DGB&retattr=cn%20sn%20o%20ou%20mail%20rfc822mailbox%20telephoneNumber%20facsimileTelephoneNumber%20postalAddress%20title%20personalTitle%20roomNumber%20description%20jpegPhoto&attr=Full%20Name&maxresults=10&term=jonnes&type=approximates"


proc ServerDown {host port} {

    cgi_p "Sorry - the Ldap server $host:$port is currently unavailable"
    footer
    exit
}


cgi_http_head {
    cgi_content_type text/html
}

set items [cgi_import_list]

foreach i $items {
    cgi_import $i
}

set title "Aston University - search results for $attr which $type '$term'"

cgi_title $title



cgi_body bgcolor=white {
    
    cgi_p [cgi_img /lis/minilogo.gif ALT="Aston University"]
    cgi_h3 $title
    if [catch {LdapBind $host $port {} {}} Conn] {
	ServerDown $host $port
    }
    
    if {$term==""} {
	NoSearchTerm
    }

    switch -exact $type {
	"contains" { set tp {=*} }
	"ends with" { set tp {=*} }
	"approximates" { set tp {~=} }
	default {set tp =}
    }

    switch -exact $attr {
	"full name" {set filter "cn$tp$term"}
	"family name" { set filter "sn$tp$term"}
	"email address" {set filter "mail$tp$term"}
    }

    switch -exact $type {
	"contains" { set filter "$filter*"}
	"starts with" {set filter "$filter*"}
	default {set filter $filter}
    }

    if {$attr=="Email Address"} {
	if [string find $term @]==-1 {
	    set filter "$filter@aston.ac.uk"
	}
    }

    set ret [LdapSearch $Conn sub {} $base $maxresults $filter $retattr]
    LdapUnBind $Conn

    foreach r $ret {
	set t [split $r =]
	set addr [lindex $t 1]
	switch -exact [lindex $t 0] {
	    mail {puts "mail=[cgi_url $addr "mailto:$addr"]" }
	    postalAddress { regsub -all { \$} $r {,} r
	                    puts $r}
	    default { puts $r}
	}
	cgi_br
    }
    footer
    
}
